package cn.wisenergy.mapper;

import cn.wisenergy.model.app.WorkDept;
import cn.wisenergy.model.dto.DeptOfProjectAndOrderType;
import cn.wisenergy.model.dto.OrganizationStructureDto;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author chenqi
 * @since 2021-01-19
 */
public interface WorkDeptMapper extends BaseMapper<WorkDept> {

    List<WorkDept> getDeptByCondition(Map<String, Object> map);

    List<OrganizationStructureDto> getAllDeptByAllCentre();

    WorkDept getById(Integer deptId);

    int updateManagerIdISNullById(Integer id);

    List<WorkDept> getDeptByManagerId(Integer userId);

    List<DeptOfProjectAndOrderType> getDeptOfProjectAndOrderType(@Param("userId") Integer userId, @Param("deptId") Integer deptId);

    /**
     * 根据用户主键查询所在部门的oa编号
     * @param userId
     * @return
     */
    WorkDept getOaDeptNoByUserId(Integer userId);

    /**
     * 获取所有部门信息
     * @return
     */
    List<WorkDept> getAllDept();

}
