package cn.wisenergy.model.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;


@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="CreateProjectVo", description="添加项目/商机Vo类")
public class CreateProjectVo {

    @ApiModelProperty(name = "type",value = "1:项目，2：商机")
    private Integer type;

    @ApiModelProperty(name = "oaProjectId",value = "OA中的项目编号")
    private String oaProjectId;

    @ApiModelProperty(name = "projectName",value = "项目名称")
    private String projectName;

    @ApiModelProperty(name = "creatorId",value = "创建人id")
    private Integer creatorId;

    @JsonFormat(shape=JsonFormat.Shape.STRING,pattern = "yyyy-MM-dd")
    @ApiModelProperty(name = "startTime",value = "项目开始时间")
    private Date startTime;

    @JsonFormat(shape=JsonFormat.Shape.STRING,pattern = "yyyy-MM-dd")
    @ApiModelProperty(name = "endTime",value = "项目结束时间")
    private Date endTime;

    @ApiModelProperty(name = "workTime",value = "工时预算")
    private BigDecimal workTime;

    @ApiModelProperty(name = "costBudget",value = "成本预算,以元为单位")
    private BigDecimal costBudget;

    @ApiModelProperty(name = "managerId",value = "项目经理userId")
    private Integer managerId;

    @ApiModelProperty(name = "userIds",value = "参与人员id")
    private List<Integer> userIds;

    @ApiModelProperty(name = "deptId",value = "部门id")
    private Integer deptId;

    @ApiModelProperty(name = "businessId",value = "商机编号")
    private String businessId;

    @ApiModelProperty(name = "businessName",value = "商机名称")
    private String businessName;
}
